Program mr2s;                       { mr2s binder program, 15/05/1999 am }
{$M $5000,0,$4000}
{$I-,R-,S-,V-,D+,L+}
{$IFNDEF FPC} {$G+} {$ENDIF}

{ -------------------[ history, see history.doc ]------------------------


  $Log: mr2s.pas $
  Revision 1.5  2001/06/25 17:40:23  rar_ulm
  1.17 for VTC test. Added approx 100 VBS/HTML and 100 HLLx viruses

  Revision 1.4  2001/06/09 13:47:04  rar_ulm
  Version 1.16 - VBE/JSE + anti heuristic VBS

  Revision 1.3  2000/12/23 16:33:15  Zimmern
  lock file enhanced

  Revision 1.2  2000/12/23 16:28:59  Zimmern
  rcs 5.7.4
  mr2s 1.14 -> 1.15

  Revision 1.1  2000/12/23 16:25:21  Zimmern
  Initial revision

  ------- old version history -------------------------------------------

  0.97  - rar, added brute force log file scanning
  0.98  - rar, bug fixing for vtc
  0.99  - rar, translated to English, Statistic, GuruHeadLine etc. FIXED WRONG COUNTING!
  1.00  - rar, 12-sept-99, relase 1.00, fixed NT 4.00 NTFS problem
  1.01  - rar, 14-nov-99
  1.02  - rar, 11-april-2000, only signature update from RHBVS, lChk>0 - rar, 06-May-2000, released
  1.03 - ah, fixed counter bug, adding semaphor file and changed the output style
  1.03p2 - rar, 04-aug-99, fixed wherey-1
  1.10  - rar, 04-June-2000, source code released, 600 new trojans, 100 new viruses added. Check added if dir is empty
  1.11  - rar, 09-July-2000, new viruses, changed layout of the .OVR files
  1.12  - rar, 17-Aug-2000, new viruses, compiled with FPC 1.00
  1.13  - rar, 13-Sept-2000, new viruses, Win32 Stealth Live Bait test
  1.14  - rar, 03-Dec-2000, new viruses, rewritten mr2s_rs/ants engine
        - rar, 23-Dec-2000, put into RCS


  Requests:
  - show an percentange indicator
  - port to Linux

  ----------------------------------------------------------------------- }


uses
{$IFDEF haak}
unzip, chkpak,
{$ENDIF}

{$IFDEF ROSE}
test286, syserr, netzwerk, dosv2,  {nt bug paramstr(0)}
{$ENDIF}
crt, dos;

Const NAME  = 'Mr2S - Version 1.17 (July 2001)';

Type str120 = string[120];

Var report : str120;
    r, lock: text;
    lDirs, lChk, lFound : longint;
    t, v : Byte;
    szHomeDir : String;         { whereis mr2s.exe? }

(* ************************************************************************ *)

Function GuruHeadLine(szWork: String) : String; { -=[ Text ]=- }

Var szTmp : String;
    bW    : Byte;

Begin

   bW := lo(windmax)-lo(windmin)-1;

   szTmp := '-[ '+szWork+' ]-';
   while length(szTmp) < bW
         Do szTmp := szTmp + '';

   GuruHeadLine := szTmp;

End; { GuruHeadLine }

{ ------------------------------------------------------------------ }

Function FileExists(FileName: String): Boolean;

Var
  F: file;

Begin
  {$I-}
  Assign(F, FileName);
  Reset(F);
  Close(F);
  {$I+}
  FileExists := (IOResult = 0) And (FileName <> '');
End;  { FileExists }

{ ------------------------------------------------------------------ }

Function FORMAT(zahl : Longint): STRING;  { 1.12.93, rar }

Var A,Hi             : STRING;
    T                : INTEGER;
    Rest             : Longint;

Begin

  A := '';
  If Zahl<1000 Then STR(zahl,a)
  Else
    Begin
      WHILE Zahl>0 Do
      Begin
           Rest := zahl-(zahl Div 1000) * 1000;
           Zahl := (zahl Div 1000);
           STR(rest:3,Hi);
           If (Hi[1]=' ') Then Hi := COPY(Hi,2,LENGTH(Hi)-1);
           If (Hi[1]=' ') Then Hi := COPY(Hi,2,LENGTH(Hi)-1);
           T := LENGTH(Hi);
           Hi := COPY('000'+Hi,t+1,t+3);
           Hi := COPY(Hi,1,3);

           A := Hi+'.'+a;
      End;

      A := COPY(a,1,LENGTH(a)-1); { Punkt am Ende entfernen }
      For T:=1 To 3 Do
        Begin
          If A[1]='0' Then A := COPY(a,2,LENGTH(a)-1);
        End;
    End;  { if then }

  Format := a;

End; { Function }

{ --- [Writeln1 ] ------------------------------------------------------- }

Procedure writeln1(szWhat: String); { 17.03.96, rar }

Begin
     For t := 1 To length(szWhat) Do
       Begin
          v := byte(szWhat[t]);
          textcolor(7);
          If v < 48 Then textcolor(3);
          If v In [91..96] Then textcolor(3+8);
          If v > 122 Then textcolor(1+8);
          If v = 254 Then textcolor(white);
          (* if (chr(v) in ['A'..'Z']) then textcolor(11); *)
          write(szWhat[t]);
       End;
     textcolor(7);
     writeln;

End; { writeln1 }

Procedure write1(szWas: String); { 17.03.96, rar }

Begin
     For t := 1 To length(szWas) Do
       Begin
          v := byte(szWas[t]);
          textcolor(7);
          If v < 48 Then textcolor(3);
          If v In [91..96] Then textcolor(3+8);
          If v > 122 Then textcolor(1+8);
          If v = 254 Then textcolor(white);
          (* if (chr(v) in ['A'..'Z']) then textcolor(11); *)
          write(szWas[t]);
       End;
     textcolor(7);

End; { write1 }

{ --- [Statistik] --------------------------------------------------------- }

Procedure Statistik;  { 08.01.97, rar }

Var s : String;

 Function sFormat(l : LongInt) : String;

 Var s : String;

 Begin { format }
   s := Format(l);
   while length(s) < 10 Do s := ' '+s;
   sFormat := s;
 End; { format }

Begin { Statistik }
   clreol;
   writeln;
   writeln1(GuruHeadLine('Statistics'));
   writeln;
   writeln1(' Files checked ................................ '+sformat(lChk));
   If lChk>0 Then str(lFound*100 / lChk:3:1,s) { fpc100 }
            Else s := '0.0';
   writeln1(' Suspicious files ............................. '+sformat(lFound)+'  ('+s+
   '%)');
   writeln1(' Directories scanned .......................... '+sformat(lDirs));
   writeln;
   writeln1(GuruHeadLine('Scanning finished! Have a virus free time!'));

End; { Statistik }

{ ####################   Routinen   ######################## }

Function upstring(st : String) : string; {Hinweis: Ohne Umlaute!!!}

Var lauf1 : byte;
Begin
  For lauf1:=1 To length(st) Do
    st[lauf1] := upcase(st[lauf1]);
  upstring := st;
End;

{ ####################   Routinen   ######################## }

Function TrimR(InpStr: String): string;       { fixed 21.04.97, rar }
{ strip trailing spaces from a String }

Var i : Byte;

Begin
   i := length(InpStr);
   While (i >= 1) and (InpStr[i] In [#9,' ',#255]) Do
      i := i - 1;
   TrimR := Copy(InpStr,1,i)
End;

{ ------------------------------------------------------------------------ }
{ Call - Working Horse - Call all scanners, read the logs and process them }
{ ------------------------------------------------------------------------ }

Procedure call(wo : str120);  { am, 15.05.99 }

Var t,t2   : text;
    lauf   : integer;
    st,st2 : string;      { fixed, 17.05.99, rar }
    i, n   : integer;
    n1, n2 : Byte;
    szF1, szF2 : String;  { filename from the files1 & files2 }
    szV1, szV2 : String;  { Virus, if found }
    sr         : SearchRec;

Begin

  findfirst(wo+'*.*', anyfile-directory-volumeid, sr);

  If (doserror = 18) Then  { nothing to do! }
       exit;               { q'n'd speed up, rar 6.june.2000 }

  textcolor(lightgray);
  write(wo);  { \ Vernderte Verzeichnisausgabe (ah) }
  clreol;     { /                                    }

   swapvectors;
   exec(szHomeDir+'\mr2ssub1.exe',wo);
   exec(szHomeDir+'\mr2ssub2.exe',wo);
   swapvectors;

  {$I-}
  assign(t,'sub1.rep');                         { <---- $$$$$$$$$$$$$$$ }
  reset(t);

  For lauf:=1 To 2 Do
    readln(t,st);   { tscan }

  readln(t, st);
  st := TrimR(st);

  If (st<>'') Then
    Repeat
      inc(lChk);

      n1 := Pos(' - ',st);
      If n1 = 0 { found? }
        Then n1 := 255;

      szF1 := TrimR(copy(st, 1, n1));

    { brute force from beginning }
      assign(t2,'mr2ssub2.rep');
      reset(t2);
      Repeat
          readln(t2, st2);
          n2 := Pos(' - ',st2);
          If n2 = 0 { found? }
             Then n2 := 255;

          szF2 := TrimR(copy(st2, 1, n2));

    { -- debug -- }
    { writeln(r, 'FN: //',szf1,'//',szf2,'//'); }

      Until eof(t2) Or (szF1 = szF2);
      close(t2);

    { ok, now cat them together

      szF1 = szF2 = FileName
      n1, n2 - pos of Virus

    }

      szV1 := copy(st, n1+3, 255);
      szV2 := copy(st2, n2+3, 255);


    { -- debug -- }
    { writeln(r, 'VN: //',szv1,'//',szv2,'//'); }

      st := szF1;

      If szV2 <> '' Then
        Begin
          If szV1 = '' Then st := st + ' - ' + szV2
                      Else st := st + ' - ' + szV1 + ' ('+szV2+')';
        End
       Else
         If szV1 <> '' Then st := st + ' - ' + szV1;

 { -------------------------------------------------------------- }

      If pos(' - ',st)<>0 Then
        Begin
          textcolor(red);

      { --- VSP/RHBVS don`t uses "Infektion" --- }
          If (Pos('Infektion: ', st) = 0) And (Pos('Warnung', st) = 0)
             And (Pos('Fehler', st) = 0) Then
            Begin
              n := Pos(' - ', st);
              st := copy(st, 1, n+2)+'Infektion: '+copy(st,n+3,255);
            End;

          n := Pos('Infektion:', st);
          If n > 1 Then
            Begin
                         inc(lFound);
                         st[n+4] := 'c';  { Infection }
                    End;
          writeln(st);                   { Ausgabe falls Virus gefunden }
        End
      Else textcolor(lightgray);


      If report<>'' Then writeln(r,st);

      readln(t, st);

    Until (st='') Or eof(t);

  close(t);
  { ------------------------ aufrumen -------------------- }
  erase(t2);
  If ioresult <> 0 Then { mr2s_rs: sux };
  erase(t);

{$I+}

  i := ioresult;
  If i<>0 Then
    Begin
      textcolor(lightred);
      writeln(#7'!!! Fatal: I/O-Error !!!'#7);
      textcolor(lightgray);
    End;
End;

{ ------------------------------------------------------------------ }

Procedure suchedateien(p : str120);

Var gg : searchrec;
Begin
  inc(lDirs);
  If p[length(p)]<>'\' Then p := upstring(p)+'\'
  Else p := upstring(p);
  findfirst(p+'*.*',anyfile,gg);
  while (doserror=0) Do
  Begin
    With gg Do
      Begin
        If (name[1]<>#46) And ((attr And volumeid)=0) Then
          Begin
            If attr And directory=0 Then
              Begin

          { skip files! }

              End
            Else
              Begin
          {$IFDEF HAAK}
                chkpak(p+name+#92);
          {$ENDIF}
                call(p+name+#92);
                suchedateien(p+name+#92); {rekursiv}
              End;
          End;
      End;
    findnext(gg);
  End;
End;

{ ------------------------------------------------------------------ }

Procedure scanne(p : str120);
Begin
  p := upstring(p);
  {writeln('Directory to scan: '+p+#13#10);}

  p := upstring(p);
  If p[length(p)]<>'\' Then p := p+'\';
  call(p);
  suchedateien(p);

  gotoxy(1,wherey);
  clreol;
End;

{ ------------------------------------------------------------------ }

Var path : str120;
    antwort: char;

Begin
  lDirs := 0;
  lChk := 0;
  lFound := 0;

  writeln;
  writeln1(GuruHeadLine('Mr. Double Scan - '+NAME));
  writeln ('(c) 1989-2001 Andreas Haak, Andreas Marx & Ralph Roth - ALL RIGHTS RESERVED!')
  ;

  { deletefile('lock.dat'); }
  If fileexists('lock.dat') Then
    Begin
      writeln;
      writeln1('A lock file was found. Do NOT start Mr2S in several tasks!');
      writeln1('If you continue and Mr2S is still active, Mr2S will crash!');
      write1('Do you want to continue (y/N) ?');
      antwort := readkey;
      writeln1(antwort);
      If upcase(antwort)<>'Y' Then halt(1);
    End;

  assign(lock,'lock.dat');
  rewrite(lock);
  writeln(lock,'MrDoubleScan - LockFile! Please do not delete!');
  writeln(lock,'$Header: C:/TP/MARX/RCS/mr2s.pas 1.5 2001/06/25 17:40:23 rar_ulm Exp $');
  close(lock);

  GetDir(0, szHomeDir);

  swapvectors;
  exec(szHomeDir+'\mr2s_chk.ovr','');
  swapvectors;
  writeln;

  If paramcount=0 Then
    Begin
      writeln1(GuruHeadLine('Usage'));
      writeln ('mr2s   drive:\[path2scan]   [name_of_logfile]');
      writeln;
      writeln ('Internal version $Id: mr2s.pas 1.5 2001/06/25 17:40:23 rar_ulm Exp $');
      erase(lock);
      halt(1);
    End;
  path := paramstr(1);
  If paramcount=2 Then report := paramstr(2)
  Else report := '';

  If report<>'' Then
    Begin
      assign(r,report);
      rewrite(r);

      writeln(r);
      writeln(r,'--- ',Name,' --- Report --- START ---');
      writeln(r);
    End;

  writeln1(GuruHeadLine(Path));
  scanne(path);

  Statistik;

  If report<>'' Then
    Begin
      writeln(r);
      writeln(r,'--- ',name,' --- Report --- END ---');
      writeln(r);

      writeln(r,'Directories scanned: ',lDirs);
      If lChk <> 0 Then
        writeln(r,'Files scanned: '+Format(lChk)+', suspious: '+Format(lFound)
           +' (',(lFound*100 / lChk): 2: 2,'%)');   { fpc100 }
      writeln(r,#13#10);

      close(r);
    End;
  erase(lock);

  close(OutPut);
  chdir(szHomeDir);

End.
